> For the complete documentation index, see [llms.txt](https://docs.arkelectron.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.arkelectron.com/products/sensor/ark-flow/firmware.md).

# Firmware

ARK Flow runs the [PX4 DroneCAN Firmware](https://docs.px4.io/main/en/dronecan/px4_cannode_fw.html). As such, it supports firmware update over the CAN bus and [dynamic node allocation](https://docs.px4.io/main/en/dronecan/#node-id-allocation).

The flight controller flashes the node firmware over CAN.

{% embed url="<https://docs.px4.io/main/en/dronecan/#firmware-update>" %}

ARK Flow boards ship with recent firmware pre-installed, but if you want to build and flash the latest firmware yourself see [PX4 DroneCAN Firmware > Building the Firmware](https://docs.px4.io/main/en/dronecan/px4_cannode_fw.html#building-the-firmware).

* Firmware target: `ark_can-flow_default`
* Bootloader target: `ark_can-flow_canbootloader`

## Downloads

{% file src="/files/BjaVFVkettd00ULYzgIe" %}
ARK Flow Firmware
{% endfile %}

{% file src="/files/g5hpKwQTBBBo1PR1ia5l" %}
ARK Flow Bootloader
{% endfile %}

## Node Parameters

Set these on the ARK Flow, then reboot it. Use [QGroundControl](https://docs.px4.io/main/en/dronecan/#qgc-cannode-parameter-configuration), where each CAN node is a separate *Component X* under **Vehicle Settings > Parameters**, or the [DroneCAN GUI Tool](/knowledge-base/knowledge-base/dronecan-gui-tool-guide.md). Defaults are those of the firmware above.

| Parameter          | Default | Description                                                                                                                                                                                |
| ------------------ | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `CANNODE_TERM`     | 0       | Set to `1` on the last node of the CAN bus                                                                                                                                                 |
| `CANNODE_PUB_IMU`  | 0       | Set to `1` to publish `RawIMU` messages on the CAN bus. PX4 also needs `UAVCAN_SUB_IMU` set to `1`                                                                                         |
| `SENS_AFBR_MODE`   | 0       | Distance sensor measurement mode. `0` short range, `1` long range, `2` high speed short range, `3` high speed long range                                                                   |
| `SENS_AFBR_S_RATE` | 50      | Distance sensor measurement rate in Hz below the switching distance                                                                                                                        |
| `SENS_AFBR_L_RATE` | 25      | Distance sensor measurement rate in Hz above the switching distance                                                                                                                        |
| `SENS_AFBR_THRESH` | 4       | Switching distance in m. The rate changes to `SENS_AFBR_L_RATE` above `SENS_AFBR_THRESH` + `SENS_AFBR_HYSTER` and back to `SENS_AFBR_S_RATE` below `SENS_AFBR_THRESH` − `SENS_AFBR_HYSTER` |
| `SENS_AFBR_HYSTER` | 1       | Hysteresis in m around `SENS_AFBR_THRESH`                                                                                                                                                  |

## Release Notes

### v1.16 - 3c45b562 - 2025-09-26

* Migrate to build server

### v1.16 - afb2c08b - 2025-08-06

* AFBRS50: Fix long range measurement publishing

### v1.16 - 2248a40e - 2025-07-10

* [AFBRS40: fix Range Mode switching](https://github.com/PX4/PX4-Autopilot/pull/25185)

### v1.16 - d0bfa548 - 2025-06-12

* [AFBRS50 fix scheduling and refactor](https://github.com/PX4/PX4-Autopilot/pull/24837)

### v1.15 - 82ff8744 - 2025-06-11

* Add DroneCAN RawIMU publisher

### v1.16 - 61036f77 - 2025-02-07

* Update to [AFBR 1.6.5 API](https://github.com/Broadcom/AFBR-S50-API/releases/tag/v1.6.5)
  * Improved distance sensor performance


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.arkelectron.com/products/sensor/ark-flow/firmware.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
